import { Component, OnInit } from '@angular/core';
import { Boilerplate } from 'src/app/models/boilerplate.model';
import { BoilerplateData } from 'src/app/models/boilerplate.model';
import { BoilerplateService } from 'src/app/services/boilerplate.service';
import { PrefixService } from 'src/app/services/prefix.service';



@Component({
  selector: 'app-boilerplate-list',
  templateUrl: './boilerplate-list.component.html',
  styleUrls: ['./boilerplate-list.component.scss']
})

export class BoilerplateListComponent implements OnInit {

  boilerplates?: Boilerplate[];
  boilerplatesdata?: BoilerplateData[];
  currentBoilerplate?: Boilerplate;
  currentBoilerplatedata?: BoilerplateData;
  currentIndex = -1;
  title = '';
  displayedColumns: string[] = ['id', 'title', 'has_prefix', 'has_main', 'has_suffix', 'action'];
  newdisplayedColumns: string[] = ['id','title_data' ,'prefix_data', 'main_data', 'suffix_data', 'action'];
  dataSource :Boilerplate[] = [{}];
  newdataSource:BoilerplateData[] = [{}];

  dataofboilerplates: any [] = [];
  aprefix: any [] = [];
  main: any;
  suffix: any;
  
  constructor(private boilerplateService: BoilerplateService, private prefixService: PrefixService) { }

  ngOnInit(): void {
    this.retrieveBoilerplates();
    this.retrieve();
  }

  retrieveBoilerplates(): void {
    this.boilerplateService.getAll()
      .subscribe(
        data => {
          this.boilerplates = data;
          this.dataSource = data;
        },
        error => {
          console.log(error);
        });

  }


  retrieve(): void {
    this.boilerplateService.getAllData()
      .subscribe(
        data => {
          this.boilerplatesdata =data;
          this.newdataSource = data;
          console.log(data)
        },
        error => {
          console.log(error);
        });

  }

  refreshList(): void {
    this.retrieveBoilerplates();
    this.currentBoilerplate = undefined;
    this.currentIndex = -1;
  }

  setActiveBoilerplate(boilerplate: Boilerplate, index: number): void {
    this.currentBoilerplate = boilerplate;
    this.currentIndex = index;
  }


  SearchTitle(): void {
    if (this.title != ''){
      this.boilerplateService.findByTitle(this.title)
        .subscribe(
          data => {
            this.boilerplates = data;
            this.dataSource = data;
            console.log(data);
          },
          error => {
            console.log(error);
          });

  } 
    else {
      this.retrieveBoilerplates();
    }
  }

}
